cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
# Create a CMakeLists.txt file to pack an arduino library into a CMake project.
# Parameters:
# -- <folder>: the compiler folder to pack.
# -- --all: pack all compilers inside
#    `$ENV{HOME}/.arduino15/packages/*/hardware/*/*/tools/sdk/*`
# -- --help, -h, -help, help: print this help

function(printHelp)
    message("cmake -P PackArduinoCompiler.cmake -- [<options>]")
    message("    Pack an Arduino compiler inside a CMakeLists.txt file")
    message("")
    message("<folder>: the folder of the compiler to pack")
    message("--all: pack all compilers inside")
    message("    \$ENV{HOME}/.arduino15/packages/*/hardware/*/*/tools/sdk/*")
    message("--help, -help, -h, help: print this help")
    message("")
endfunction(printHelp)

function(appendSet TARGET FOLDER DEPENDENCIES)
    if (NOT(("${DEPENDENCIES}" STREQUAL "")))
        file(APPEND "${FOLDER}/CMakeLists.txt"
            "set(${TARGET}\n"
            "${DEPENDENCIES}"
            ")\n"
            "\n"
        )
    else()
        file(APPEND "${FOLDER}/CMakeLists.txt"
            "set(${TARGET} )\n"
            "\n"
        )
    endif()
endfunction(appendSet)

function(packInclude FOLDER)
    message("Packing: ${FOLDER}")
    get_filename_component(FOLDER "${FOLDER}" ABSOLUTE)
    if (FOLDER MATCHES ".*/$")
        string(REGEX REPLACE  "(.*)." "\\1" FOLDER "${FOLDER}")
    endif()

    set(INCS )

    file(GLOB_RECURSE INCS_TMP LIST_DIRECTORIES true RELATIVE "${FOLDER}" "${FOLDER}/include")
    foreach(FILE ${INCS_TMP})
        if ((IS_DIRECTORY "${FOLDER}/${FILE}") AND ("${FILE}" MATCHES "include.*"))
            list(APPEND INCS "    \"\${CMAKE_CURRENT_LIST_DIR}/${FILE}\"\n")
        endif()
    endforeach()
    string(REGEX REPLACE ";" "" INCS "${INCS}")

    get_filename_component(LIB_NAME "${FOLDER}" NAME)

    file(WRITE "${FOLDER}/CMakeLists.txt"
        "# Automatically generated by PackArduinoCompiler.cmake\n"
        "\n"
    )
    appendSet("${LIB_NAME}_INCLUDES" "${FOLDER}" "${INCS}")
endfunction(packInclude)

function(packAll)
    file(GLOB DIR_LIST LIST_DIRECTORIES true "$ENV{HOME}/.arduino15/packages/*/hardware/*/*/tools/sdk/*")
    foreach(DIR ${DIR_LIST})
        if (IS_DIRECTORY "${DIR}")
            #packInclude("${DIR}")
            message("AAAA ${DIR}")
        endif ()
    endforeach()
endfunction(packAll)

function(parseCommandLine)
    if (NOT(${CMAKE_ARGC} EQUAL 5))
        printHelp()
    endif()
    if ("${CMAKE_ARGV4}" STREQUAL "--all")
        packAll()
    elseif ("${CMAKE_ARGV4}" STREQUAL "--help"
        OR "${CMAKE_ARGV4}" STREQUAL "-help"
        OR "${CMAKE_ARGV4}" STREQUAL "-h"
        OR "${CMAKE_ARGV4}" STREQUAL "help")
        printHelp()
    else()
        packInclude("${CMAKE_ARGV4}")
    endif()
endfunction(parseCommandLine)

parseCommandLine()
